<?php

/**
 * Plugin Name: Essential Breadcrumbs
 * Description: Creates breadcrumbs based on the URL structure that are schema marked up.
 * Version: 1.1.1
 * Author: Essential Marketer
 * Author URI: http://www.essentialmarketer.com
 * License: GPLv2 or later
 */

/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// Make sure we don't expose any info if called directly

if ( !function_exists( 'add_action' ) ) {
	echo "ERROR: Plugin can not be called directly";
	exit;
}

if ( is_admin() ){

    if( isset($_GET["page"]) ):
        function essential_breadcrumbs_enqueue($hook) {
            if ( $_GET["page"] == 'essential-breadcrumbs' ):
                wp_enqueue_style( 'wp-color-picker' );
                wp_enqueue_script( 'essential-breadcrumbs-js', plugin_dir_url( __FILE__ ) . 'js/essential-breadcrumbs.js', array( 'wp-color-picker' ) );
                wp_enqueue_style( 'essential-breadcrumbs-css', plugin_dir_url( __FILE__ ) . 'css/essential-breadcrumbs.css' );
            else:
                return;
            endif;
        }
        add_action( 'admin_enqueue_scripts', 'essential_breadcrumbs_enqueue' );
    endif;

	require_once dirname( __FILE__ ) . '/admin/admin.php';
}

require_once dirname( __FILE__ ) . '/essential_breadcrumb_functions.php';