<?php

function emb_shortcode( $atts ){

        $emb_text = get_option('emb_text');
        $urls_generated_by_cp = get_option('urls_generated_by_cp');
        $emb_breadcrumb_seperator = get_option('emb_breadcrumb_seperator');

        $site_url = get_site_url();
        if( get_option('page_for_posts' ) ):
            $blog_url = get_permalink( get_option('page_for_posts' ) );
            $blog_url = str_replace('/', '', str_replace($site_url, '', $blog_url));
        else:
            $blog_url = $site_url;
        endif;
        $blog_page_id = get_option('page_for_posts' );

        if( is_category() ):
            $queried_object = get_queried_object();
            $cat_name = $queried_object->name;
            $cat_url = $queried_object->slug;
        endif;

        if( is_single() ):
            $single_object = get_queried_object();
            $post_category_id = $single_object->post_category;
            if($post_category_id):
                $post_category = get_category($post_category_id[0]);
                $post_cat_name = $post_category->name;
                $post_cat_url = $post_category->slug;
            endif;
        endif; 

        if(!$emb_breadcrumb_seperator):
            $emb_breadcrumb_seperator = ' > ';
        endif;

    	$count = 2;
    	$breadcrumb_url = '';
    	$current_url = parse_url($_SERVER["REQUEST_URI"]);
        $current_parsed_url = $current_url["path"];
    	$current_url_pieces = array_filter(explode( '/', $current_parsed_url));
        $last_item = end($current_url_pieces);
        $amount = count($current_url_pieces);

    	echo '<div class="essential-breadcrumbs">';
            if( $emb_text ):
                echo '<p>'.$emb_text.'</p>';
            endif;
    		echo '<ol vocab="http://schema.org/" typeof="BreadcrumbList">';
                echo '<li property="itemListElement" typeof="ListItem">';
                    echo '<a property="item" typeof="WebPage" href="/"><span property="name">Home</span></a>';
                    echo '<meta property="position" content="1">';
                echo '</li>';
                if($amount >= 1):
                    echo '<span class="emb-seperator">'.$emb_breadcrumb_seperator.'</span>';
                endif;
	    		foreach( $current_url_pieces as $breadcrumb_url_part ):
                    $breadcrumb_url .= $breadcrumb_url_part.'/';
                    $breadcrumb_post_id = emb_custom_url_to_postid( $breadcrumb_url );
                    if(!$breadcrumb_post_id):
                        $breadcrumb_post_id = url_to_postid( $breadcrumb_url );
                    endif;
	    			echo '<li property="itemListElement" typeof="ListItem">';
                        if( $breadcrumb_url_part == $blog_url ):
                            echo '<a property="item" typeof="WebPage" href="/'.$breadcrumb_url.'"><span property="name">'.get_the_essential_breadcrumbs_title($blog_page_id).'</span></a>';
                        elseif( is_category() ):
                            if( $breadcrumb_url_part == $cat_url ):
                                echo '<a property="item" typeof="WebPage" href="/'.$cat_url.'"><span property="name">'.$cat_name.'</span></a>';
                            else:
                                echo '<a property="item" typeof="WebPage" href="/'.$breadcrumb_url.'"><span property="name">'.get_the_essential_breadcrumbs_title($breadcrumb_post_id).'</span></a>';
                            endif;
                        elseif( is_single() ):
                            if( $breadcrumb_url_part == $post_cat_url ):
                                echo '<a property="item" typeof="WebPage" href="/'.$post_cat_url.'"><span property="name">'.$post_cat_name.'</span></a>';
                            else:
                                echo '<a property="item" typeof="WebPage" href="/'.$breadcrumb_url.'"><span property="name">'.get_the_essential_breadcrumbs_title($breadcrumb_post_id).'</span></a>';
                            endif;
                        else:
                            echo '<a property="item" typeof="WebPage" href="/'.$breadcrumb_url.'"><span property="name">'.get_the_essential_breadcrumbs_title($breadcrumb_post_id).'</span></a>';
                        endif;
	    				echo '<meta property="position" content="'.$count.'">';
	  				echo '</li>';
                    if($breadcrumb_url_part != $last_item):
                        echo '<span class="emb-seperator">'.$emb_breadcrumb_seperator.'</span>';
                    endif;
	  				$count++;
	    		endforeach;
    		echo '</ol>';
    	echo '</div>';
}
add_shortcode( 'emb', 'emb_shortcode' );

function essential_breadcrumbs_styles(){
	wp_enqueue_style( 'essential-breadcrumbs-css', plugin_dir_url( __FILE__ ) . 'css/front-end-essential-breadcrumbs.css' );
}
add_action( 'wp_enqueue_scripts', 'essential_breadcrumbs_styles' );

function emb_custom_url_to_postid( $url ){

    global $wpdb;

    $results = $wpdb->get_results("SELECT post_id FROM ".$wpdb->prefix."postmeta WHERE meta_key = 'custom_permalink' AND meta_value = '$url'");
    $post_id = '';

    if($results):
        $post_id = $results[0]->post_id;
    else:
        $url = preg_replace('{/$}', '', $url);
        $results = $wpdb->get_results("SELECT post_id FROM ".$wpdb->prefix."postmeta WHERE meta_key = 'custom_permalink' AND meta_value = '$url'");
        if($results):
            $post_id = $results[0]->post_id;
        endif;
    endif;

    if($post_id):
        return $post_id;
    endif;
}

function get_the_essential_breadcrumbs_title( $post_id ){

    $title = get_post_meta( $post_id, 'essential_breadcrumbs_title', true );
    if(!$title):
        $title = get_the_title( $post_id );
    endif;
    
    return $title;
}

function add_essential_breadcrumbs_custom_css(){

    $emb_custom_css = get_option('emb_breadcrumb_custom_css');
    if($emb_custom_css):
        $output = '<!-- ADDED BY ESSENTIAL MARKETER BREADCRUMBS -->'.PHP_EOL;
            $output .= '<style type="text/css">'.PHP_EOL;
                $output .= $emb_custom_css.PHP_EOL;
            $output .= '</style>'.PHP_EOL;
        $output .= '<!-- ADDED BY ESSENTIAL MARKETER BREADCRUMBS -->'.PHP_EOL;

        echo $output;
    endif;
}
add_action('wp_head','add_essential_breadcrumbs_custom_css');